using namespace std;
#include<iostream>
#include <stdio.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>
#include<cmath>  //note: math functions are all double as standard
#include "extern_proto.h"

 int i;
 int bst_left;
 int bst_right;
 int no_node;
 int sorted_node;
 int max_leaves;
 int nprefix,nvar_in;
 float **prefix;
 float ratio[10],sum_T_m_save;
 int min_tree;
 int **next_right_node;
 int **next_left_node;
 int **previous_node;
 //These variables give the node number of the next node....
 //For example next_left_node(12,itree) will give the node
 //number of the left node following node 12 for itree.
 //Similarly for previous node.
 int num_sig,num_bkrd,num_train_sig,num_train_bkrd,num_train_tot;
 int num_file_tree_old;
//These are the number of signal and background events. 
 int **node_var;
 float **node_val;
 //These are the variable used at this node and its cut point.
 float **purity_right;
 float **purity_left;
 float* cut_crit_node;
 float* wrong_class; float* alpha_m;
 int *evt_last_node;
 int *leftright_from_last; 
 int *leftright_from_parent;
 int num_available_sig, num_available_bkrd,num_available;
 int *list_available;
 float *weight_tot;
 float *weight_left_leaf_var;
 float *weight_right_leaf_var;
 float **train_dat;
 float **test_dat_sig;
 float **test_dat_bkrd;
 int **sorted_index_train;
 float *weight, *weight2;
 float **event_dat;
 float **sum_T_m_dat;
 int num_data;
 int num_train_for_tree,num_var_for_node;
 int *list_train_for_tree;
 int *list_var_for_node;
 float min_ratio;
 int itree_last;
 int min_node_size;
//variables for make_node
 int nsig,nbkrd,best_var,last_node;
 float best_value,*var_max,*var_min;
//for make_node for bins
 float wgt_sig_temp,wgt_bkrd_temp;
 float **wgt_in_bin_sig,**wgt_in_bin_bkrd,**bin_value;
 float *step,*wgt_bin_evts_sig,*wgt_bin_evts_bkrd,*val_bin_evts;
  int *nbinj;
 float *tempval;
 int* sorted_list_T_m_sig, *sorted_list_T_m_bkrd;
 float *sum_T_m_sig,*sum_T_m_bkrd;
 int *times_var_used,*sorted_times_index;
 int **next_right_node_save;
 int **next_left_node_save;
 int **node_var_save;
 float**node_val_save;
 float**purity_right_save;
 float**purity_left_save;
 float *alpha_m_save;
 float weight_bkrd_temp,weight_sig_temp,weight_temp;

 int main()
{
  extern int initialize();
  extern int readin_data();
  extern int sort_data();
  extern int loop_over_trees();
  extern int data_loop_over_trees();
  extern int ending_part();
  int iresult;
  iresult = initialize();
     if (iresult) 
       {cout<<"Error on initialization \n";
        return iresult;}
  iresult = readin_data();
     if (iresult) 
       {cout<<"Error on readin_data \n";
        return iresult;}
     if (!training_or_data)  //training run
       {
	 iresult = sort_data();
	 if (iresult)
	   {cout<<"error on sort_data \n";
	   return iresult;}
	 cout<<"end of readin_data \n";
	 iresult = loop_over_trees();
	 if (iresult) 
	   {cout<<"Error on loop over trees \n";
	   return iresult;}
	 cout<<"end of loop_over_trees \n";
       }
     else  //data run
       {
	 iresult = data_loop_over_trees();
	 if (iresult) 
	   {cout<<"Error on data loop over trees \n";
	   return iresult;}
	 cout<<"end of data_loop_over_trees \n";
       }
       iresult = ending_part();
       if (iresult)          {cout<<"Error on ending part \n";
         return iresult;}
       cout<<"end of ending_part \n";
       fflush(stdout);
       return 0;
}  //end of main

     int initialize()
{ //1
	 int i,j;
	 extern int get_files(char* filein2);
	 extern int rmarin(int , int );
	 extern int declare_var();
         extern int get_parameters(char* filein);
   i= get_parameters("boost_param.input");
   if (i) 
     {cout<<"Error in reading in parameters";return 1;}

   cout<<"training_or_data = "<<training_or_data<<"\n";
   cout<<"nevt_max = "<<nevt_max<<"\n";
   cout<<"nvar = "<<nvar<<"\n";
   cout<<"nvar_in = "<<nvar_in<<"\n";
   cout<<"nprefix = "<<nprefix<<"\n";
   cout<<"ada_or_epsilon = "<<ada_or_epsilon<<"\n";
   cout<<"epsilon = "<<epsilon<<"\n";
   cout<<"alpha_const = "<<alpha_const<<"\n";
   cout<<"randomize_training_sample = "<<randomize_training_sample<<"\n";
   cout<<"random_seed = "<<random_seed<<"\n";
   cout<<"purity_cut = "<<purity_cut<<"\n";
   cout<<"max_nodes = "<<max_nodes<<"\n";
   cout<<"max_num_trees = "<<max_num_trees<<"\n";
   cout<<"fraction_train_for_tree = "<<fraction_train_for_tree<<"\n";
   cout<<"fraction_var_for_node = "<<fraction_var_for_node<<"\n";
   cout<<"boost_bins = "<<boost_bins<<"\n";
   cout<<"min_node = "<<min_node<<"\n";
   cout<<"num_bins = "<<num_bins<<"\n";
   cout<<"min_bin_size = "<<min_bin_size<<"\n";
   cout<<"test_every_kth_tree = "<<test_every_kth_tree<<"\n";
   cout<<"min_allowed_weight = "<<min_allowed_weight<<"\n";
   cout<<"training_size_sig = "<<training_size_sig<<"\n";
   cout<<"training_size_bkrd = "<<training_size_bkrd<<"\n";
   cout<<"trim_wgt = "<<trim_wgt<<"\n";
   cout<<"without_replace = "<<without_replace<<"\n";
   cout<<"weight_wrong_evts = "<<weight_wrong_evts<<"\n";
   cout<<"soft_score = "<<soft_score<<"\n";
   //set min_node_size
   if (boost_bins)  min_node_size = 2*min_bin_size; //boost_bins
   else min_node_size =  min_node;  //boost_evts
   //
   i= get_files("boost_files.input");
   if (i) 
     {cout<<"Error on reading get_files \n";return 1;}
   cout<<"num_file_sig = "<< num_file_sig<<"\n";
   if (num_file_sig>0) 
     {
       for(j=0;j<num_file_sig;j++)
	 {cout<<"file "<<j<<" = "<<file_sig[j]<<"\n";}
     }
   cout<<"num_file_bkrd = "<< num_file_bkrd<<"\n";
   if (num_file_bkrd>0) 
     {
       for(j=0;j<num_file_bkrd;j++)
	 {cout<<"file "<<j<<" = "<<file_bkrd[j]<<"\n";}
     }
   cout<<"num_file_data = "<< num_file_data<<"\n";
   if (num_file_data>0) 
     {
       for(j=0;j<num_file_data;j++)
	 {cout<<"file "<<j<<" = "<<file_data[j]<<"\n";}
     }
   cout<<"num_file_tree = "<< num_file_tree<<"\n";
   if (num_file_tree>0) 
     {
       for(j=0;j<num_file_tree;j++)
	 {cout<<"file "<<j<<" = "<<file_tree[j]<<"\n";}
     }
   cout<<"num_file_data_out = "<< num_file_data_out<<"\n";
   if (num_file_data_out>0) 
     {
       for(j=0;j<num_file_data_out;j++)
	 {cout<<"file "<<j<<"  = "<<file_data_out[j]<<"\n";}
     }
   //Check input for consistency
      if (!training_or_data)  //if this is a training run
    {if (!num_file_sig ||!num_file_bkrd)
      {cout<<"training run but num_file_sig= "<<num_file_sig
	   <<" num_file_bkrd = "<<num_file_bkrd<<"\n"; return 1;}
    if (num_file_data) 
      {cout<<"training run but num_data_file = "<<num_file_data<<"\n";
       return 1;}
     }
   else  //if this is a data run
    {if (num_file_sig ||num_file_bkrd)
      {cout<<"data run but num_file_sig = "<< num_file_sig
	   <<" num_file_bkrd = "<<num_file_bkrd<<"\n"; return 1;}
    if (!num_file_data||!num_file_tree) 
      {cout<<"data run but num_file_data = "<<num_file_data
	   <<" and num_file_tree = "<<num_file_tree<<"\n";
      return 1;}
    }
   //
   //initialize random number
   i = rmarin(1357,random_seed);
   bst_left=1;
   bst_right=-1;
   no_node=-2;
   sorted_node=1000;
   max_leaves=(max_nodes+1)/2;
   cout<<"nevt_max = "<<nevt_max<<" nvar = "<<nvar<<" "<<"nvar_in = "
       <<nvar_in<<"\n";
   cout<<"max_nodes = "<<max_nodes<<" max_num_trees = "<<max_num_trees<<"\n";
   //do initialization for multiple dimension variables
  if (nprefix>0)
    {
      prefix = (float**)malloc(sizeof(float*)*nevt_max);
      for (i=0;i<nprefix;i++)
	prefix[i] =(float*)malloc(sizeof(float)*nprefix);
    }
 previous_node= (int**)malloc(sizeof(int*)*max_nodes);
 //These variables give the node number of the next node....
 //For example next_left_node(12,itree) will give the node
 //number of the left node following node 12 for itree.
 //Similarly for previous node.
//These are the number of signal and background events. 
 node_var= (int**)malloc(sizeof(int*)*max_nodes);
 node_val= (float**)malloc(sizeof(float*)*max_nodes);
 //These are the variable used at this node and its cut point.
 purity_right= (float**)malloc(sizeof(float*)*max_nodes);
 purity_left= (float**)malloc(sizeof(float*)*max_nodes);
 evt_last_node= (int*)malloc(sizeof(int*)*2*nevt_max);
 leftright_from_last= (int*)malloc(sizeof(int*)*2*nevt_max);
 tempval = (float*)malloc(sizeof(float*)*nvar);
 //Generally for loop over trees
 sorted_list_T_m_sig = (int*)malloc(sizeof(int*)*nevt_max);
 sorted_list_T_m_bkrd = (int*)malloc(sizeof(int*)*nevt_max);
 sum_T_m_sig = (float*)malloc(sizeof(float)*nevt_max); 
 sum_T_m_bkrd = (float*)malloc(sizeof(float)*nevt_max);
  times_var_used =(int*)malloc(sizeof(int)*(nvar+1));
  sorted_times_index =(int*)malloc(sizeof(int)*(nvar));
  next_right_node_save = (int**)malloc(sizeof(int*)*max_nodes);
  next_left_node_save = (int**)malloc(sizeof(int*)*max_nodes);
  node_var_save =(int**)malloc(sizeof(int*)*max_nodes);
  node_val_save =(float**)malloc(sizeof(float*)*max_nodes);
  purity_right_save =(float**)malloc(sizeof(float*)*max_nodes);
  purity_left_save =(float**)malloc(sizeof(float*)*max_nodes);
  alpha_m_save =(float*)malloc(sizeof(float)*max_num_trees);
  int ievt,ivar,iresult,ind1,ind2;
  float temp;
  int itree =0;
  for (i=0;i<max_nodes;i++)
    {
      next_right_node_save[i] = (int*)malloc(sizeof(int)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      next_left_node_save[i] = (int*)malloc(sizeof(int)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      node_var_save[i] = (int*)malloc(sizeof(int)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      node_val_save[i] = (float*)malloc(sizeof(float)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      purity_right_save[i] = (float*)malloc(sizeof(float)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      purity_left_save[i] = (float*)malloc(sizeof(float)*max_num_trees);
    }
  for (i=0;i<max_nodes;i++)
    {
      node_val_save[i] = (float*)malloc(sizeof(float)*max_num_trees);
    }
  if (!training_or_data) 
   {  //here for training run
     list_train_for_tree = (int*)malloc(sizeof(int)*nevt_max);
     list_var_for_node = (int*)malloc(sizeof(int*)*nvar);
 train_dat= (float**)malloc(sizeof(float*)*2*nevt_max);
 test_dat_sig= (float**)malloc(sizeof(float*)*nevt_max);
 test_dat_bkrd= (float**)malloc(sizeof(float*)*nevt_max); 
   }
 else
   {  //here for data run
 event_dat = (float**)malloc(sizeof(float*)*nevt_max);

 sum_T_m_dat = (float**)malloc(sizeof(float*)*20);
 //Assume never have more than 20 sum_T_m's
    for(i=0;i<20;i++)
   {
     sum_T_m_dat[i] =(float*)malloc(sizeof(float)*nevt_max);
   }
   }//end of data run init here
  next_right_node= (int**)malloc(sizeof(int*)*max_nodes);

 for(i=0;i<max_nodes;i++)
   {
     next_right_node[i]=(int*)malloc(sizeof(int)*max_num_trees);
   }
  next_left_node= (int**)malloc(sizeof(int*)*max_nodes);

 for(i=0;i<max_nodes;i++)
 { 
 
   next_left_node[i]=(int*)malloc(sizeof(int)*max_num_trees);
 }
 for(i=0;i<max_nodes;i++)
   {
     previous_node[i]=(int*)malloc(sizeof(int)*max_num_trees);
   }
 
 //These variables give the node number of the next node....
 //For example next_left_node(12,itree) will give the node
 //number of the left node following node 12 for itree.
 //Similarly for previous node.

//These are the number of signal and background events. 
   //!!!!test kludge
 //    if (i != 10) return 0;
  
   for(i=0;i<max_nodes;i++)
    {
     node_var[i]=(int*)malloc(sizeof(int)*max_num_trees);
  }

     for(i=0;i<max_nodes;i++)
   {
    node_val[i]=(float*)malloc(sizeof(float)*max_num_trees);
   }
   //!!!!test kludge
   //if (i != 10) return 0;
 
//These are the variable used at this node and its cut point.
 for(i=0;i<max_nodes;i++)
   {
     purity_right[i]=(float*)malloc(sizeof(float)*max_num_trees);
   }
 for(i=0;i<max_nodes;i++)
   {
     purity_left[i]=(float*)malloc(sizeof(float)*max_num_trees);
   }
   if(!training_or_data) 
     {
     //training run
       for(i=0;i<nevt_max;i++)
         {
           train_dat[i]=(float*)malloc(sizeof(float)*nvar_in);
         } 
       for(i=0;i<nevt_max;i++)
	 {
	   test_dat_sig[i]=(float*)malloc(sizeof(float)*nvar_in);
	 }
       for(i=0;i<nevt_max;i++)
	 {
	   test_dat_bkrd[i]=(float*)malloc(sizeof(float)*nvar_in);
	 }
     }// end of if training run
   else 
     {    //here if data run
       for(i=0;i<nevt_max;i++)
	 {
	   event_dat[i] = (float*)malloc(sizeof(float)*nvar_in);
	 }
     }  //end of if data run
   sorted_index_train= (int**)malloc(sizeof(int*)*2*nevt_max);
   for(i=0;i<2*nevt_max;i++)
     {
       sorted_index_train[i]=(int*)malloc(sizeof(int)*nvar);
     }
   cut_crit_node =(float*)malloc(sizeof(float)*max_nodes);
   wrong_class =(float*)malloc(sizeof(float)*nevt_max);
   alpha_m = (float*)malloc(sizeof(float)*max_num_trees);
   leftright_from_parent =(int*)malloc(sizeof(int)*max_nodes);
   list_available =(int*)malloc(sizeof(int)*nevt_max); 
   weight_tot =(float*)malloc(sizeof(float)*max_nodes);
   weight_left_leaf_var =(float*)malloc(sizeof(float)*max_nodes);
   weight_right_leaf_var =(float*)malloc(sizeof(float)*max_nodes);
   weight = (float *)malloc(sizeof(float)*2*nevt_max);
   weight2 = (float *)malloc(sizeof(float)*2*nevt_max);
   //variables for make_node
   var_max = (float *)malloc(sizeof(float)*nvar);
   var_min = (float *)malloc(sizeof(float)*nvar);
   if (boost_bins)
     {
       wgt_in_bin_sig = (float**)malloc(sizeof(float*)*nvar);
       for(i=0;i<nvar;i++)
	 {
	   wgt_in_bin_sig[i] =(float*)malloc(sizeof(float)*num_bins);
	 }
       wgt_in_bin_bkrd = (float**)malloc(sizeof(float*)*nvar);
       for(i=0;i<nvar;i++)
	 {
	   wgt_in_bin_bkrd[i] =(float*)malloc(sizeof(float)*num_bins);
	 }
       step =(float*)malloc(sizeof(float)*nvar);
       bin_value=(float**)malloc(sizeof(float*)*nvar);
       for(i=0;i<nvar;i++)
	 {
	   bin_value[i]=(float*)malloc(sizeof(float)*(num_bins+1));
	 }
       wgt_bin_evts_sig =(float*)malloc(sizeof(float)*nevt_max);
       wgt_bin_evts_bkrd =(float*)malloc(sizeof(float)*nevt_max);
       val_bin_evts=(float*)malloc(sizeof(float)*nevt_max);
       nbinj =(int*)malloc(sizeof(int)*nvar);
     }
   return 0;
}//end of initialize

void choose_train_evts(int* choose_for_train, int num_sample,int ntotrain) {
  int ievt,iselect;
  float float_sample;
  extern void vsetval(int*, int, int);
  extern float ranmar1();
  vsetval(choose_for_train,num_sample,0);
  if (randomize_training_sample) {
     ievt = 1;
     float_sample = (float)num_sample;
     do {
       iselect = (int) (ranmar1()*float_sample);
       iselect = min(iselect,num_sample);
       if (choose_for_train[iselect] !=1) 
                {choose_for_train[iselect] = 1;ievt++;}
        }while (ievt<ntotrain);
  }
  else
    //do not pick events randomly
    for(ievt=0;ievt<ntotrain;ievt++) {choose_for_train[ievt]=1;}
return; }
int sort_data()
{
  //This program,for each variable, sorts the events by value from smallest
  //to largest.
  extern void Sort(int,float*,int*,bool);
  int ivar;
  int i;
  float *test_train;
  test_train = (float *)malloc(sizeof(float)*2*nevt_max);
  int *temp_sort;
  temp_sort = (int *)calloc(1,sizeof(int)*2*nevt_max);
  for (ivar=0;ivar<nvar;ivar++)
    {
      for(i = 0;i<num_train_tot;i++)
	{test_train[i] = train_dat[i][ivar];
	}
      Sort(num_train_tot,test_train,temp_sort,0);
      //sort so that lowest value is first.
            for(i=0;i<num_train_tot;i++)
      	sorted_index_train[i][ivar] = temp_sort[i];
	    //	    if (sorted_index_train[0][ivar])cout<<"sort--0--ivar "<<ivar<<" "<<sorted_index_train[0][ivar]<<" train_dat "<<train_dat[sorted_index_train[0][ivar]][ivar]<<"\n";
	    //	          if (sorted_index_train[1][ivar])cout<<"sort--2000--ivar "<<ivar<<" "<<sorted_index_train[2000][ivar]<<" train_dat "<<train_dat[sorted_index_train[2000][ivar]][ivar]<<"\n";
	    //    if (sorted_index_train[2][ivar])cout<<"sort--max--ivar "<<ivar<<" "<<sorted_index_train[num_train_tot-1][ivar]<<"train_dat"<<train_dat[sorted_index_train[num_train_tot-1][ivar]][ivar]<<"\n";
    }
   
      cout<<"data sorted \n";
      return 0;
}
     
