//CSTR.H - Declaration of the CStr class

class CStr {
  char *pData;
  int nLength;

 public:
  CStr();    //Constructors
  CStr( char *s);
  CStr(const CStr &str);
  ~CStr();  //Destructor

  char *get(void) const {return pData;}
  int getlength(void) const {return nLength;}
  void cpy(char *s);
  void cat(char *s);

    friend CStr operator+(CStr strl, CStr str2);
    friend CStr operator+(CStr str, char *s);
    friend CStr operator+(char *s, CStr str);

    CStr& operator=(const CStr &source)
    {cpy(source.get()); return *this;}
    operator const char*() {return get();}
};
