using namespace std;
#include<fstream>
#include<iostream>
#include <cstdlib>
#include<string.h>
#include<ctype.h>
#include<math.h>
#include "extern_proto.h"
//
// Function to read in data for boost
// B. Roe, Jan 2, 2005
//
int readin_data()
{ //1
    //  FILE *fpsig; FILE *fpbkrd;
  //  int num_sig,num_bkrd;
  int ievt1,ievt_sig,ievt_bkrd,ievt_train,ivar,ievt_data,i;
  int ifile,num_sample,nvar_temp;
  int num_data_temp,num_file_tree_old_temp,isum;
  extern void choose_train_evts(int* ,int , int );
  int* choose_for_train;
  float dum;
  choose_for_train =(int*)malloc(sizeof(int)*nevt_max);
  if (!training_or_data) 
    {//2
    //here for training run
      if (!num_file_sig||!num_file_bkrd) {
	cout<<"Error, training run but num_file_sig,numfile_bkrd = " <<
	  num_file_sig<<" "<<num_file_bkrd<<"\n";
	return 1;}
      ievt_sig = 0;
      ievt_bkrd = 0;
      ievt_train = 0;
      for(ifile=0;ifile<num_file_sig;ifile++)
	{ //3
	  std::ifstream from_sig (file_sig[ifile]);
	  cout<< "input file ="<< ifile <<" " << file_sig[ifile]<<" \n";
	  if (!from_sig) {cout<<"Cannot open input file "
			      <<ifile<<"\n";return 1;}
	  //caution:  Need to revise if more than 1 input file!!!
	  from_sig>>num_sig>>num_bkrd;
	  cout <<"num_sig =" << num_sig<<" num_bkrd = "<<num_bkrd<<'\n';
	  // for test resetting parameters:
	  //        if (num_sig == 32) {  //ie never
	  if(from_sig.eof())
	    {
	      cout<<"error reading num events on file "<< 
			     file_sig[ifile]<<"\n";
	    }
	  if (training_size_sig+training_size_bkrd == 0) 
	    {
	      num_train_sig = min(num_sig,num_bkrd)/2;
	      num_train_bkrd = num_train_sig;
	      num_train_tot = 2*num_train_sig;
	    }
	  else 
	    { 
	      num_train_sig = training_size_sig;
	      num_train_bkrd = training_size_bkrd;
	      num_train_tot = training_size_sig+training_size_bkrd;
	      if ((num_train_sig > (num_sig-500))||
		  (num_train_bkrd >(num_bkrd-500))) {
		cout<<"Too many training evts--sig,bkrd,trainsig,trainbkrd,"
		    <<"num_train_tot= "<<num_sig<<num_bkrd<<" "<< 
		  num_train_sig<<" "<<num_train_bkrd<<" "<<num_train_tot<<"\n";
		return 1;}
	    } 
	  num_sample = num_sig;
	  //Caution:  the following needs redoing if more than 1 input file
	  
	  choose_train_evts(choose_for_train,num_sample,num_train_sig);
	  //  select a scrambled training set	
	  //	  cout<<"nprefix,nvar_in ="<<nprefix<<" "<<nvar_in<<"\n";
	  for(ievt1 = 0;ievt1<num_sig;ievt1++) 
	    { //4
	      if (choose_for_train[ievt1]==0) 
		{//5
		  //test event
		  //readin event into (test_dat_sig(ievt_sig,ivar),ivar=1,nvar)
		  if (nprefix>0)
		    {
		      for (i=0;i<nprefix;i++) from_sig>>dum;
		    }
		  for (ivar =0;ivar<nvar_in;ivar++)
		    {
		      from_sig>> test_dat_sig[ievt_sig][ivar] ;
		      //       	    cout<<"I got past the sig readin \n";
		    }
		  ievt_sig++;
		}//5
	      else 
		{//5
		  //readin event into (train_dat_sig(ievt_train,ivar)
		  //,ivar=1,nvar)
		  //training event
		  if (nprefix>0)
		    {
		      for (i=0;i<nprefix;i++) from_sig>>dum;
		    }
		  for (ivar =0;ivar<nvar_in;ivar++) 
		    {
		      from_sig>>train_dat[ievt_train][ivar];
		    }
		  ievt_train++;
		  //if (ievt_train<3)cout<<"ievt_train,1stvar"<<ievt_train
		  //	       <<" "<<train_dat[ievt_train-1][0]<<"\n";
		}//5
	    } //4  end sum over sig events
	  num_sample = num_bkrd;
	  choose_train_evts(choose_for_train,num_sample,num_train_bkrd);
	  for(ievt1 = 0;ievt1<num_bkrd;ievt1++) {//4again
	    if (choose_for_train[ievt1]==0) 
	      {
		//test event
		//readin event into (test_dat_bkrd(ievt_bkrd,ivar),ivar=1,nvar)
		if (nprefix>0)
		  {
		    for (i=0;i<nprefix;i++) from_sig>>dum;
		  }
		for (ivar =0;ivar<nvar_in;ivar++)
		  {
		    from_sig>>test_dat_bkrd[ievt_bkrd][ivar];
		  }
		ievt_bkrd++; 
	      }
	      else 
		{
		  //readin event into (train_dat(ievt_train,ivar),ivar=1,nvar)
		  //training event
		  if (nprefix>0)
		    {
		      for (i=0;i<nprefix;i++) from_sig>>dum;
		    }
		  for (ivar =0;ivar<nvar_in;ivar++)
		    {
		      from_sig>>train_dat[ievt_train][ivar];
		    }
		  ievt_train++; 
		}
	      
	  } //4 again  end of sum over events for background
	} //3  end of loop over files
      
    }//2 choose for training or data
  else //here for data
    {//2
      cout<<"I am at the start of readin for data";
      num_data = 0;
      if (!num_file_data) {
	cout<<"Error, data run but num_file_data is 0" <<"\n";
	return 1;}
      ievt_data = 0;
      for(ifile=0;ifile<num_file_data;ifile++)
	{//3
	  std::ifstream from_data (file_data[ifile]);
	  cout<< "input file ="<< ifile <<" " << file_sig[ifile]<<" \n";
	  if (!from_data) {cout<<"Cannot open input data file "<<ifile
			       <<" "<<file_data[ifile]<<"\n";return 1;}
	  from_data>>num_data_temp;
	  cout<<"num_data in file "<<file_data[ifile]<< " = "
	      <<num_data_temp<<"\n";
	  num_data = num_data_temp + num_data;
	  //	num_data_temp= num_data_temp-1000;//temporary kludge
	  //num_data = num_data_temp;//temporary kludge
	  from_data>>num_file_tree_old_temp;
	  from_data>>nvar_temp;
	  if (nvar_temp !=nvar_in)
	    {
	      cout<<" Error nvar_in = "<<nvar_in<<" nvar_temp = "<<nvar_temp
		  <<"\n";
	      return 1;
	    }
	  //  cout<<"I have read in the first parameters,num_data,num_old,nvar "
	  //<<num_data<<" "<<num_file_tree_old_temp<<" "<<nvar<<"\n";
	  if ((ifile)&&(num_file_tree_old_temp!=num_file_tree_old))
	    {cout<<"Unmatched number of existing sum_T_m_dat "<<
	       num_file_tree_old<<" "<<num_file_tree_old_temp<<"\n";
	    return 1;
	    }
	  num_file_tree_old = num_file_tree_old_temp;
	  for(ievt_data = 0;ievt_data<num_data_temp;ievt_data++) 
	    { //4
	      if (nprefix>0)
		{
		  for (i=0;i<nprefix;i++) from_data>>prefix[ievt_data][i];
		}
	      if (num_file_tree_old>0)
		{
		  for (isum = 0;isum<num_file_tree_old;isum++)
		    {
		      from_data>>sum_T_m_dat[isum][ievt_data];
		    }
		}
	      //cout<<"I am about to read event_dat "<<ievt_data<<"\n";
	      for (ivar =0;ivar<nvar_in;ivar++) 
		{
		  from_data>>event_dat[ievt_data][ivar]; 
		  // if (ivar==1)cout<<"ievt_data,ivar,event_dat[ievt_data] = "
		  //  <<ievt_data<<" "<<ivar<<" "<<event_dat[ievt_data][ivar]
		  //  <<"\n";
		}
	      //if (ievt_data ==num_data_temp-1)cout<<"at evt "
	      //<<ievt_data<<" \n";
	    }//4
	  //cout<<"I have read in the data \n";
	}//3
    } //2  here for data
  cout<<" end of data readin \n";
  return 0;
}//1
